﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Runtime.InteropServices;

//-----------------www.EasySoft.ir---------------
namespace EasySoft
{
    class Program
    {
        static StreamReader streamReader = new StreamReader("..//..//elimination_2014_problem_F.in");
        static StreamWriter streamWriter = new StreamWriter("..//..//elimination_2014_problem_F.out");

        static void chmin(ref long t, long f)
        {
            if (t > f)
            {
                t = f;
            }
        }

        static void chmax(ref long t, long f)
        {
            if (t < f)
            {
                t = f;
            }
        }

        const long INF = 1001001001001001001L;

        static int N;
        static int[] A = new int[5010];
        static int[,] mn = new int[5010, 5010];
        static int[,] mx = new int[5010, 5010];
        static long[,] dp = new long[5010, 5010];

        static bool isValid(int i, int j)
        {
            return (mx[i, j] - mn[i, j] == j - i - 1);
        }

        static long calc(int i, int j)
        {
            long ret = dp[i, j];
            if (ret == -1)
            {
                if (j - i == 1)
                {
                    ret = 0;
                }
                else
                {
                    ret = INF;
                    for (int k = i + 1; k < j; ++k)
                    {
                        if (isValid(i, k) && isValid(k, j))
                        {
                            long a = k - i;
                            long b = j - k;
                            long tmp = calc(i, k) + calc(k, j);
                            tmp += a * (a - 1) * (b - 1);
                            tmp += 2 * a * b * (a + b - 1);
                            chmin(ref ret, tmp);
                            break;
                        }
                    }
                    for (int k = j - 1; k > i; --k)
                    {
                        if (isValid(i, k) && isValid(k, j))
                        {
                            long a = k - i;
                            long b = j - k;
                            long tmp = calc(i, k) + calc(k, j);
                            tmp += b * (b - 1) * (a - 1);
                            tmp += 2 * a * b * (a + b - 1);
                            chmin(ref ret, tmp);
                            break;
                        }
                    }
                }
            }
            return ret;
        }

        static void Main(string[] args)
        {
            int T = int.Parse(streamReader.ReadLine());
            for (int t = 0; t < T; t++)
            {
                streamReader.ReadLine();
                N = int.Parse(streamReader.ReadLine());

                string[] str = streamReader.ReadLine().Split(' ');
                for (int i = 0; i < N; i++)
                {
                    A[i] = int.Parse(str[i]);
                }

                for (int i = 0; i < N; ++i)
                {
                    mn[i, i + 1] = A[i];
                    mx[i, i + 1] = A[i];
                    for (int j = i + 1; j < N; ++j)
                    {
                        mn[i, j + 1] = Math.Min(mn[i, j], A[j]);
                        mx[i, j + 1] = Math.Max(mx[i, j], A[j]);
                    }
                }

                for (int i = 0; i <= N; ++i)
                {
                    for (int j = i; j < N + 1; j++)
                    {
                        dp[i, j] = -1;
                    }
                }
                
                long res = calc(0, N);

                streamWriter.WriteLine("Case #" + (t + 1).ToString() + ":");
                if (res >= INF)
                {
                    streamWriter.WriteLine("-1");
                }
                else
                {
                    streamWriter.WriteLine(res.ToString());
                }
            }

            streamReader.Close();
            streamWriter.Close();
        }
    }
}
